<?
	/*
		$psql = new psqldb;

		if( $psql->select( "SELECT * FROM BLA")) {
			while( $row = $psql->fetch_row()) {
				echo $psql->row('bla');
			}
		}

	*/

	class dbpg {
		var $conf = array();

		var $connection;
		var $debug;
		var $debug_sql;
		var $error = array();

		var $row_num;
		var $row_current;
		var $row_data;
		var $row_result;

		function dbpg( $hostname = "localhost", $username = "root", $password = "wat3f4all", $database = "krueger") {
			$this->conf['hostname'] = $hostname;
			$this->conf['username'] = $username;
			$this->conf['password'] = $password;
			$this->conf['database'] = $database;

			$this->connection = false;
			$this->debug = 0;
			$this->debug_sql = 0;
			$this->error = array();

			$this->row_num = 0;
			$this->row_result = 0;
			$this->row_current = 0;
			$this->row_data = array();
		}

		function connect() {
			if( $this->debug)
				echo "called ".get_class( $this)."->connect()\n";

			$connectstring = "";
			if( $this->connection == false) {
				$connectstring = 'host='.$this->conf['hostname'].' user='.$this->conf['username'].' password='.$this->conf['password'].' dbname='.$this->conf['database'];
				if( $this->debug == 1) echo "connectstring -> $connectstring\n";
				if( ($this->connection = pg_connect( $connectstring)) == false) {
					$this->get_error();
					if( $this->debug)
						echo "connect() failed\n";
				} else
					if( $this->debug) {
						echo "connect() succeeded\n";
						echo "connectLink = ".gettype( $this->connection)."\n";
						var_dump( $this->connection);
						echo "\n";
					}
			}
			return $this->connection;
		}

		function query( $sql) {
			if( $this->debug_sql == 1) echo "<pre>$sql</pre>";
			if( $this->connection == false)
				if( $this->connect() == false) {
					if( !empty( $this->error['message']))
						$this->set_error( "Can't connect");
					return false;
				}

			if( ( $this->row_result = pg_exec( $this->connection, $sql)) == false) {
				$this->get_error();
				if( !empty( $this->error['message']))
					$this->set_error( "Query failed");
				return false;
			}
			if( ( $this->row_num = pg_numrows( $this->row_result)) == -1) {
				$this->set_error( "Can't fetch number of rows");
				return false;
			} else {
				$this->row_current = 0;
				$this->row_data = array();
				return true;
			}
		}

		function fetch_row( $whichrow = -1) {
			if( $this->connection == false || $this->row_num == -1)
				return false;
			if( $whichrow == -1) {
				if( $this->row_current < $this->row_num) {
					$this->row_data = pg_fetch_array( $this->row_result, $this->row_current++, PGSQL_ASSOC);
					if( $this->row_data == false)
						$this->get_error();
					return $this->row_data;
				} else
					return false;
			} else {
				if( $whichrow < $row_num) {
					$this->row_data = pg_Fetch_array( $this->row_result, $whichrow, PGSQL_ASSOC);
					if( $this->row_data == false)
						$this->get_error();
					return $this->row_data;
				} else
					return false;
			}
		}

		function row( $rowname) {
			if( $this->row_data == false)
				return false;
			if( gettype( $this->row_data[strtolower( $rowname)]) == "NULL") {
				if( $this->debug == 1)
					echo "<pre>No match for row '$rowname'</pre>";
			} else {
				return $this->row_data[ strtolower( $rowname)];
			}
		}

		function get_error() {
			$this->error = array();
			$this->error['message'] = pg_errormessage( $this->connection);
		}

		function set_error( $message) {
			if( strlen( $message))
				$this->error['message'] = $message;
		}
	}
?>
